using System;
using System.Collections.Generic;
using System.Text;

namespace SatAMGame
{
    class Animation
    {
        int _currentFrame = 0;
        int _numberOfFrames = 0;
        static int _gameLoopCounter = 0;
        List<Frame> _animationFrames = new List<Frame>();

        #region Properties
        public int CurrentFrame
        {
            get { return _currentFrame; }
            set { _currentFrame = value; }
        }

        public int NumberOfFrames
        {
            get { return _numberOfFrames; }
            set { _numberOfFrames = value; }
        }

        public List<Frame> AnimationFrames
        {
            get { return _animationFrames; }
            set { _animationFrames = value; }
        }
        #endregion

        public void ResetCounter()
        {
            _gameLoopCounter = 0;
        }

        public void ResetAnimation()
        {
            CurrentFrame = 0;
        }

        public void Next()
        {
            if (_animationFrames[CurrentFrame].IsAnimate &&
                NumberOfFrames > 1 &&
                _gameLoopCounter++ == _animationFrames[CurrentFrame].FrameDelay)
            {
                //Reset loop counter
                _gameLoopCounter = 0;

                if (_animationFrames[CurrentFrame].Loop)
                    CurrentFrame = 0;
                else if (CurrentFrame < NumberOfFrames - 1)
                    CurrentFrame++;
            }
        }
    }
}
