using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using System.Text;

namespace SatAMGame
{
    public static class Sound
    {
        private static AudioEngine engine;
        private static WaveBank wavebank;
        private static SoundBank soundbank;

        public static void Play(string sound)
        {
            soundbank.PlayCue(sound);
        }

        public static void Play(Cue sound)
        {
            soundbank.PlayCue(sound.Name);
        }

        public static void Update()
        {
            engine.Update();
        }

        public static void Stop(Cue cue)
        {
            cue.Stop(AudioStopOptions.Immediate);
        }

        public static void Initialize()
        {
            engine = new AudioEngine(@"Sounds\satamsnd.xgs");
            wavebank = new WaveBank(engine, @"Sounds\satamsnd.xwb");
            soundbank = new SoundBank(engine, @"Sounds\satamsnd.xsb");
        }

        public static void Shutdown()
        {
            soundbank.Dispose();
            wavebank.Dispose();
            engine.Dispose();
        }
    }
}
